package cl.usm.android;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;

public class Cliente extends Activity {
	private Button btn_0, btn_1, btn_2, btn_3, btn_4, btn_5;
	private TextView ip_server;
	private TextView port_server;
	private CheckBox check_IP;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		btn_0 = (Button) findViewById(R.id.btn_0);
		btn_0.setOnClickListener(new buttonsOnClickListener());
		btn_1 = (Button) findViewById(R.id.btn_1);
		btn_1.setOnClickListener(new buttonsOnClickListener());
		btn_2 = (Button) findViewById(R.id.btn_2);
		btn_2.setOnClickListener(new buttonsOnClickListener());
		btn_3 = (Button) findViewById(R.id.btn_3);
		btn_3.setOnClickListener(new buttonsOnClickListener());
		btn_4 = (Button) findViewById(R.id.btn_4);
		btn_4.setOnClickListener(new buttonsOnClickListener());
		btn_5 = (Button) findViewById(R.id.btn_5);
		btn_5.setOnClickListener(new buttonsOnClickListener());

		ip_server = (TextView) findViewById(R.id.ip_value);
		ip_server.addTextChangedListener(new serverTextWatcher());
		port_server = (TextView) findViewById(R.id.port_value);
		port_server.addTextChangedListener(new serverTextWatcher());

		check_IP = (CheckBox) findViewById(R.id.checkBox1);
	}

	private class buttonsOnClickListener implements OnClickListener {
		public void onClick(View v) {
			// TODO Auto-generated method stub
			Socket socket = null;
			DataOutputStream dataOutputStream = null;
			DataInputStream dataInputStream = null;

			try {
				socket = new Socket(ip_server.getText().toString(),
						Integer.parseInt(port_server.getText().toString()));
				dataOutputStream = new DataOutputStream(
						socket.getOutputStream());
				dataInputStream = new DataInputStream(socket.getInputStream());

				switch (v.getId()) {
				case R.id.btn_0:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 0, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("0");
					break;
				case R.id.btn_1:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 1, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("1");
					break;
				case R.id.btn_2:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 2, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("2");
					break;
				case R.id.btn_3:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 3, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("3");
					break;
				case R.id.btn_4:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 4, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("4");
					break;
				case R.id.btn_5:
					Toast.makeText(getApplicationContext(),
							"Elegida opcion " + 5, Toast.LENGTH_SHORT).show();
					dataOutputStream.writeBytes("5");
					break;
				}

				dataOutputStream.flush();
			} catch (IOException e) {
				Log.e("Cliente", "IOException", e);
			} finally {
				if (socket != null) {
					try {
						socket.close();
					} catch (IOException e) {
						Log.e("TCP", "Socket error", e);
					}
				}
				if (dataInputStream != null) {
					try {
						dataInputStream.close();
					} catch (IOException e) {
						Log.e("TCP", "dataInputStream error", e);
					}
				}
				if (dataOutputStream != null) {
					try {
						dataOutputStream.close();
					} catch (IOException e) {
						Log.e("TCP", "dataOutputStream error", e);
					}
				}
			}
		}
	}

	private class serverTextWatcher implements TextWatcher {

		public void afterTextChanged(Editable arg0) {
			// TODO Auto-generated method stub
			String ip = ip_server.getText().toString();
			String port = port_server.getText().toString();
			if (ip.equals("192.168.0.10") && port.equals("8888"))
				check_IP.setChecked(true);
			else
				check_IP.setChecked(false);
		}

		public void beforeTextChanged(CharSequence arg0, int arg1, int arg2,
				int arg3) {
			// TODO Auto-generated method stub

		}

		public void onTextChanged(CharSequence arg0, int arg1, int arg2,
				int arg3) {
			// TODO Auto-generated method stub

		}

	}
}